package flm.b4a.animplusdemo3;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "flm.b4a.animplusdemo3", "flm.b4a.animplusdemo3.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "flm.b4a.animplusdemo3", "flm.b4a.animplusdemo3.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public flm.b4a.animationplus.AnimationPlusWrapper _animplus = null;
public anywheresoftware.b4a.objects.ImageViewWrapper _ivandroid = null;
public flm.b4a.animationplus.AnimationPlusWrapper _a1 = null;
public flm.b4a.animationplus.AnimationPlusWrapper _a2 = null;
public flm.b4a.animationplus.AnimationPlusWrapper _a3 = null;
public flm.b4a.animationplus.AnimationSet _animset = null;
public static String  _activity_click() throws Exception{
 //BA.debugLineNum = 61;BA.debugLine="Sub Activity_Click";
 //BA.debugLineNum = 62;BA.debugLine="AnimSet.Stop(ivAndroid)";
mostCurrent._animset.Stop((android.view.View)(mostCurrent._ivandroid.getObject()));
 //BA.debugLineNum = 63;BA.debugLine="End Sub";
return "";
}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 26;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 27;BA.debugLine="Activity.Color = Colors.Black";
mostCurrent._activity.setColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 28;BA.debugLine="ivAndroid.Initialize(\"\")";
mostCurrent._ivandroid.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 29;BA.debugLine="ivAndroid.SetBackgroundImage(LoadBitmap(File.DirAssets, \"left_trans.png\"))";
mostCurrent._ivandroid.SetBackgroundImage((android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"left_trans.png").getObject()));
 //BA.debugLineNum = 32;BA.debugLine="Activity.AddView(ivAndroid, -800dip, -20dip, 400dip, 600dip)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._ivandroid.getObject()),(int)(-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(800))),(int)(-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(20))),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(400)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(600)));
 //BA.debugLineNum = 34;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 58;BA.debugLine="Sub Activity_Pause(UserClosed As Boolean)";
 //BA.debugLineNum = 59;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 36;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 37;BA.debugLine="A1.InitializeTranslate(\"Anim1\", 0dip, 0dip,0dip, 0dip)";
mostCurrent._a1.InitializeTranslate(mostCurrent.activityBA,"Anim1",(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0))),(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0))),(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0))),(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0))));
 //BA.debugLineNum = 38;BA.debugLine="A1.SetInterpolator(A1.INTERPOLATOR_LINEAR)";
mostCurrent._a1.SetInterpolator(mostCurrent._a1.INTERPOLATOR_LINEAR);
 //BA.debugLineNum = 39;BA.debugLine="A1.StartOffset = 50";
mostCurrent._a1.setStartOffset((long)(50));
 //BA.debugLineNum = 41;BA.debugLine="A2.InitializeTranslate(\"Anim2\", 0dip, 0dip,400dip, 0dip)";
mostCurrent._a2.InitializeTranslate(mostCurrent.activityBA,"Anim2",(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0))),(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0))),(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(400))),(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0))));
 //BA.debugLineNum = 42;BA.debugLine="A2.SetInterpolator(A2.INTERPOLATOR_LINEAR)";
mostCurrent._a2.SetInterpolator(mostCurrent._a2.INTERPOLATOR_LINEAR);
 //BA.debugLineNum = 43;BA.debugLine="A2.StartOffset = 4000";
mostCurrent._a2.setStartOffset((long)(4000));
 //BA.debugLineNum = 45;BA.debugLine="A3.InitializeTranslate(\"Anim3\", 400dip, 0dip,0dip, 0dip)";
mostCurrent._a3.InitializeTranslate(mostCurrent.activityBA,"Anim3",(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(400))),(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0))),(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0))),(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0))));
 //BA.debugLineNum = 46;BA.debugLine="A3.SetInterpolator(A3.INTERPOLATOR_LINEAR)";
mostCurrent._a3.SetInterpolator(mostCurrent._a3.INTERPOLATOR_LINEAR);
 //BA.debugLineNum = 47;BA.debugLine="A3.StartOffset = 8000";
mostCurrent._a3.setStartOffset((long)(8000));
 //BA.debugLineNum = 49;BA.debugLine="AnimSet.Initialize(False)";
mostCurrent._animset.Initialize(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 50;BA.debugLine="AnimSet.AddAnimation(A1)";
mostCurrent._animset.AddAnimation(mostCurrent._a1);
 //BA.debugLineNum = 51;BA.debugLine="AnimSet.AddAnimation(A2)";
mostCurrent._animset.AddAnimation(mostCurrent._a2);
 //BA.debugLineNum = 52;BA.debugLine="AnimSet.AddAnimation(A3)";
mostCurrent._animset.AddAnimation(mostCurrent._a3);
 //BA.debugLineNum = 53;BA.debugLine="AnimSet.Duration = 4000";
mostCurrent._animset.setDuration((long)(4000));
 //BA.debugLineNum = 54;BA.debugLine="AnimSet.PersistAfter = True";
mostCurrent._animset.setPersistAfter(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 55;BA.debugLine="AnimSet.Start(ivAndroid)";
mostCurrent._animset.Start((android.view.View)(mostCurrent._ivandroid.getObject()));
 //BA.debugLineNum = 56;BA.debugLine="End Sub";
return "";
}
public static String  _anim1_animationend() throws Exception{
 //BA.debugLineNum = 65;BA.debugLine="Sub Anim1_AnimationEnd";
 //BA.debugLineNum = 66;BA.debugLine="Log(\"End of Anim1\")";
anywheresoftware.b4a.keywords.Common.Log("End of Anim1");
 //BA.debugLineNum = 67;BA.debugLine="End Sub";
return "";
}
public static String  _anim2_animationend() throws Exception{
 //BA.debugLineNum = 69;BA.debugLine="Sub Anim2_AnimationEnd";
 //BA.debugLineNum = 70;BA.debugLine="Log(\"End of Anim2\")";
anywheresoftware.b4a.keywords.Common.Log("End of Anim2");
 //BA.debugLineNum = 71;BA.debugLine="End Sub";
return "";
}
public static String  _anim3_animationend() throws Exception{
 //BA.debugLineNum = 73;BA.debugLine="Sub Anim3_AnimationEnd";
 //BA.debugLineNum = 74;BA.debugLine="Log(\"End of Anim3\")";
anywheresoftware.b4a.keywords.Common.Log("End of Anim3");
 //BA.debugLineNum = 75;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 17;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 20;BA.debugLine="Dim AnimPlus As AnimationPlus";
mostCurrent._animplus = new flm.b4a.animationplus.AnimationPlusWrapper();
 //BA.debugLineNum = 21;BA.debugLine="Dim ivAndroid As ImageView";
mostCurrent._ivandroid = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 22;BA.debugLine="Dim A1, A2, A3 As AnimationPlus";
mostCurrent._a1 = new flm.b4a.animationplus.AnimationPlusWrapper();
mostCurrent._a2 = new flm.b4a.animationplus.AnimationPlusWrapper();
mostCurrent._a3 = new flm.b4a.animationplus.AnimationPlusWrapper();
 //BA.debugLineNum = 23;BA.debugLine="Dim AnimSet As AnimationSet";
mostCurrent._animset = new flm.b4a.animationplus.AnimationSet();
 //BA.debugLineNum = 24;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 15;BA.debugLine="End Sub";
return "";
}
}
